/* 
   OpenMP "shared" clause example

   Jim Teresco, CS 338, Williams College
   Mon Feb 24 22:30:57 EST 2003

   $Id: openmp_shared.c,v 1.1 2003/02/25 05:37:24 terescoj Exp $
*/

#include <stdio.h>
#include <omp.h>

int main(int argc, char *argv[]) {

  int threadid = 997;

  /* by putting threadid into the shared clause, we are 
     making it available to all threads */
#pragma omp parallel shared(threadid)
  {
    /* this sure is unsafe, but it demonstrates our point */
    threadid = omp_get_thread_num();
    printf("In parallel directive, threadid=%d\n", threadid);
    
  }

  /* and when we're done, it's got the value assigned to it by the
     last thread to assign to it */
  printf("Back from parallel directive, threadid=%d\n", threadid);

  return 0;
}
